Index: trunk/SophyaLib/BaseTools/history_eros
===================================================================
--- trunk/SophyaLib/BaseTools/history_eros	(revision 478)
+++ trunk/SophyaLib/BaseTools/history_eros	(revision 480)
@@ -1,7 +1,10 @@
 SysTools from LibsUtil
+machdefs.h from machine.h defs.h
 -----------> defs.h
    Repository revision:	1.21	/projects/Eros/CVSEros/LibsUtil/defs.h,v
+   MAJ                  1.24
 -----------> machine.h
    Repository revision:	1.9	/projects/Eros/CVSEros/LibsUtil/machine.h,v
+   MAJ                  1.12
 -----------> timing.c
    Repository revision:	1.2	/projects/Eros/CVSEros/LibsUtil/timing.c,v
@@ -19,6 +22,8 @@
 -----------> pdlmgr.cc
    Repository revision:	1.2	/projects/Eros/CVSEros/CodeCxx/Outils/pdlmgr.cc,v
+   MAJ                  1.6
 -----------> pdlmgr.h
    Repository revision:	1.2	/projects/Eros/CVSEros/CodeCxx/Outils/pdlmgr.h,v
+   MAJ                  1.4
 -----------> peidainit.h
    Repository revision:	1.6	/projects/Eros/CVSEros/CodeCxx/Outils/peidainit.h,v
@@ -27,4 +32,5 @@
 -----------> periodic.h
    Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/periodic.h,v
+   MAJ                  1.5
 -----------> perrors.h
    Repository revision:	1.4	/projects/Eros/CVSEros/CodeCxx/Outils/perrors.h,v
@@ -35,4 +41,6 @@
 -----------> psighand.cc
    Repository revision:	1.2	/projects/Eros/CVSEros/CodeCxx/Outils/psighand.cc,v
+   MAJ                  1.3
 -----------> psighand.h
    Repository revision:	1.1	/projects/Eros/CVSEros/CodeCxx/Outils/psighand.h,v
+   MAJ                  1.2
Index: trunk/SophyaLib/BaseTools/machdefs.h
===================================================================
--- trunk/SophyaLib/BaseTools/machdefs.h	(revision 478)
+++ trunk/SophyaLib/BaseTools/machdefs.h	(revision 480)
@@ -26,5 +26,5 @@
 #endif
 
-#ifdef sun
+#if defined(SunOS)  || defined ( sun )
 #define MACH_SUN
 #define OS_SOLARIS
@@ -142,6 +142,11 @@
   typedef unsigned long long uint_8;
 
+#ifdef powerpc
+#define SWAP 0
+#define SWAPDEFAUT 0
+#else
 #define  SWAP 1
 #define  SWAPDEFAUT   1
+#endif
 
 #elif defined(OS_MACOS)
@@ -183,4 +188,5 @@
 /*    __aCC__      : aCC on HP                                         */
 /*    __KCC__      : KCC, version >= 3.3 is required                   */
+/*    __SGICC__    : SGI (IRIX64) CC compiler                          */
 
 /***********************************************************************/
@@ -201,4 +207,5 @@
 /*   HAS_IOS_NOCREATE                                                      */
 /*   HAS_VEC_NEW           : operator new[]                                */
+/*   CC_HAS_RTTI_SUPPORT     has Run Time Type Identification support      */
 /*   ANSI_IO               : rdbuf()->pubseekoff rather than seekg         */
 /*   HAS_STR_NPOS          : has string::npos and not a global NPOS        */
@@ -214,4 +221,8 @@
 #ifndef COMPILER_EXCEPTIONS
 #define COMPILER_EXCEPTIONS
+#endif
+
+#ifndef  CC_HAS_RTTI_SUPPORT 
+#define  CC_HAS_RTTI_SUPPORT 
 #endif
 
@@ -246,7 +257,4 @@
 
 #if defined (__aCC__)  
-#ifndef COMPILER_EXCEPTIONS
-#define COMPILER_EXCEPTIONS
-#endif
 #ifndef ANSI_TEMPLATES
 #define ANSI_TEMPLATES
@@ -258,12 +266,25 @@
 #define STREAMPOS_IS_CLASS
 #define HAS_STR_NPOS
-#ifndef COMPILER_EXCEPTIONS
-#define COMPILER_EXCEPTIONS
-#endif
 #ifndef ANSI_TEMPLATES
 #define ANSI_TEMPLATES
 #endif
-#endif
-
+/* Standard C++ library classes are in the namespace std  */
+#ifdef __cplusplus
+namespace std { }
+using namespace std;
+#endif
+#endif
+
+#if defined(__SGICC__)
+/* Standard C++ library classes are in the namespace std  */
+#define HAS_STR_NPOS
+#ifndef ANSI_TEMPLATES
+#define ANSI_TEMPLATES
+#endif
+#ifdef __cplusplus
+namespace std { }
+using namespace std;
+#endif
+#endif
 
 /* Get things has homogeneous as possible between compilers */
Index: trunk/SophyaLib/BaseTools/ppersist.h
===================================================================
--- trunk/SophyaLib/BaseTools/ppersist.h	(revision 478)
+++ trunk/SophyaLib/BaseTools/ppersist.h	(revision 480)
@@ -12,4 +12,6 @@
 #include "pexceptions.h"
 #include "md5.h"
+
+#include <time.h>
 
 #include <string>
Index: trunk/SophyaLib/Mgr/Makefile.h
===================================================================
--- trunk/SophyaLib/Mgr/Makefile.h	(revision 478)
+++ trunk/SophyaLib/Mgr/Makefile.h	(revision 480)
@@ -55,9 +55,4 @@
 #### Fortran (tout ce qui est lie au Fortran est defini ici #############
 FC = f77
-ifeq ($(SITE),CCIN2P3)
-  ifeq ($(MACHEROS),AIX)
-    override FC := xlf
-  endif
-endif
 ifeq (${MACHEROS},Linux)
 #  override FC := f77
@@ -87,6 +82,5 @@
 EXE := ${PP}/Exec/
 INC := ${DPCDEVREP}/Include/
-CCI := ${INC}/CInc/
-GLB := ${GNU}/${MACHEROS}/lib/
+GLB := /usr/local/lib/
 #--
 
@@ -99,4 +93,11 @@
 ifndef DBGFLAG
   DBGFLAG  := -g
+#  Probleme sur DEC/OSF1 -g avec g++/egcs pose probleme a l'assembleur
+#                    Reza 09/99 - On met -gcoff
+  ifeq (${MACHEROS},OSF1)
+    ifeq ($(CXX), g++)
+      override DBGFLAG := -gcoff
+    endif
+  endif
 endif
 
@@ -127,10 +128,13 @@
 #   Avec certains compilateurs C++ (KCC, aCC) , il faut fabriquer les librairies et 
 # les shared libs avec la meme commande 
-override ARCXX := 
-ifeq ($(CXX),KCC)
-ARCXX  := KCC
-endif
+override ARCXX := $(AR) 
+override ARCXXFLAGS := $(ARFLAGS) 
+#RZ0999 ifeq ($(CXX),KCC)
+#RZ0999 override  ARCXX  := KCC
+#RZ0999 override ARCXXFLAGS  := -o
+#RZ0999 endif
 ifeq ($(CXX),aCC)
-ARCXX  := aCC
+override ARCXX  := aCC 
+override ARCXXFLAGS  := -o
 endif
 
@@ -144,26 +148,9 @@
 #  Pour compiler PI, sous Linux, les includes et libs se trouve souvent ds /usr/X11/include /usr/X11/lib/
 ifeq (${MACHEROS},Linux)
-  XLDLIBS := -L/usr/X11/lib 
-  XCFLAGS := -I/usr/X11/include
+  XLDLIBS := -L/usr/X11/lib -L/usr/X11R6/lib
+  XCFLAGS := -I/usr/X11/include -I/usr/X11R6/include
   LDLIBS := -ldl
 endif
 
-# Pour RFIO
-ifeq ($(SITE),CCIN2P3)
-  XCFLAGS := $(XCFLAGS) -D RFIO -I/usr/local/include/shift
-  XLDLIBS := $(XLDLIBS) -L/usr/local/lib -lshift
-endif
-
-# Les bibliotheques gnu C pour le fort du CCPN
-ifeq ($(SITE),CCIN2P3)
- ifeq ($(CC), gcc)
-  ifeq ($(MACHEROS),HP-UX)
-     FGLIB := -L/usr/local/lib/gcc-lib/hppa1.1-hp-hpux9.05/2.7.2.1 -lgcc
-  endif
-  ifeq ($(MACHEROS),AIX)
-     FGLIB := -L/usr/local/lib/gcc-lib/rs6000-ibm-aix3.2.5/2.7.2.1 -lgcc
-  endif
- endif
-endif
 
 # Chemin pour la librairie cfitsio 
@@ -180,5 +167,5 @@
 #endif
 
-CPPFLAGS     :=  -I${INC} -I$(FITSIOREP) -D${MACHEROSD} -I$(INC)/tnt $(MODULECPPFLAGS)
+CPPFLAGS     :=  -I${INC} -I$(FITSIOREP) -D${MACHEROSD} $(MODULECPPFLAGS)
 
 # Les options selon les divers compilateurs
@@ -256,8 +243,4 @@
 endif
 
-#gcc sur Solaris
-ifeq ($(MACHEROS),SunOS)
- override NOSHLIB := Y
-endif
 
 ifeq ($(CXX), cxx)
@@ -338,6 +321,5 @@
 endif
 
-
-#  Compilateur KAI 
+# --- Compilateur KAI  (OK pour v 3.3)
 ifeq ($(CXX), KCC)
   CXXFLAGS     :=  --exceptions --rtti  --auto_instantiation --one_instantiation_per_object -D__KCC__
@@ -346,4 +328,11 @@
 endif
 
+# --- Compilateur natif CC de SGI 
+ifeq ($(MACHEROS), IRIX64)
+  ifeq ($(CXX), CC)
+    CXXFLAGS     :=  -prelink -D__SGICC__
+  endif
+endif
+
 # Autres compilateurs natifs.
 
Index: trunk/SophyaLib/Mgr/Makefile.slb
===================================================================
--- trunk/SophyaLib/Mgr/Makefile.slb	(revision 478)
+++ trunk/SophyaLib/Mgr/Makefile.slb	(revision 480)
@@ -6,4 +6,6 @@
 slbpi: slb $(SLB)libPI.so
 
+#  Chemin des librairies Motifs / X11 (pour chemin non standard)
+LIBXPATH :=
 #  Commande de construction de shared-lib 
 CMDSHL := ld -partage
@@ -19,6 +21,27 @@
 CMDTILSHL := echo 'Cas Non Prevu'
 CMDTILSHLPI := echo 'Cas Non Prevu'
-#  Chemin des librairies Motifs / X11 (pour chemin non standard)
-LIBXPATH :=
+# Utilisation du compilo C++ comme driver pour fabrication des shared-libs
+CMDSHLCXX := $(LINK.cc) 
+FGSHLACXX :=  
+FGSHLNCXX := 
+#  S'il faut utiliser $(CMDSHLCXX) pour fabrication des shared-libs
+USECXX4SO := N
+# On utilise le compilo g++ pour la fabrication des shared libs
+ifeq ($(EROSCXX), g++)
+  override USECXX4SO := Y
+  override CMDSHLCXX := $(LINK.cc) -shared
+endif
+
+# On utilise le compilo KCC pour la fabrication des shared libs
+ifeq ($(EROSCXX), KCC)
+  override USECXX4SO := Y
+  override CMDSHLCXX := $(LINK.cc)
+endif
+
+# On utilise le compilo aCC (HP) pour la fabrication des shared libs
+ifeq ($(EROSCXX), aCC)
+  override USECXX4SO := Y
+  override CMDSHLCXX := $(LINK.cc) -b
+endif
 
 # Construction de shared-libs sous OSF1
@@ -38,5 +61,7 @@
     override TILSHLPI := 
     override CMDTILSHLPI := echo 'No Template instanciation library'
+    override USECXX4SO := N
   endif
+#  Attention - Dangereux de mettre -expect_unresolved , $CHECK$  Reza 20/10/99
   override CMDSHLCXX := $(LINK.cc) -shared -expect_unresolved '*' 
   override FGSHLACXX := 
@@ -50,4 +75,7 @@
   override FGSHLN := --no-whole-archiv
   override CMDSHLCXX := $(LINK.cc) -shared 
+  ifeq ($(EROSCXX), KCC)
+    override CMDSHLCXX := $(LINK.cc)
+  endif
   override FGSHLACXX := 
   override FGSHLNCXX := 
@@ -55,5 +83,33 @@
   override TILSHL := 
   override CMDTILSHL := echo 'No Template instanciation library'
+  override LIBXPATH := -L/usr/X11/lib -L/usr/X11R6/lib
+endif
+
+# Construction de shared-libs sous Sun-OS
+ifeq ($(MACHEROS),SunOS)
+  override CMDSHL := ld -G
+  override FGSHLA := -z allextract
+  override FGSHLN := -z weakextract
+  override LIBLSHL := $(LIBG) -lm -lc
+  override TILSHL := 
+  override CMDTILSHL := echo 'No Template instanciation library'
   override LIBXPATH := -L/usr/X11/lib
+  override USECXX4SO := Y
+endif
+
+# Construction de shared-libs sous SGI
+ifeq ($(MACHEROS), IRIX64)
+  override CMDSHL := ld -shared
+  override FGSHLA := -all
+  override FGSHLN := -notall
+  override LIBLSHL := $(LIBG) -lm -lc
+  override TILSHL := 
+  override CMDTILSHL := echo 'No Template instanciation library'
+  ifeq ($(EROSCXX), CC)
+    override CMDSHLCXX := CC -shared 
+    override LIBLSHL := -lm -lc
+  endif
+  override LIBXPATH := -L/usr/X11/lib
+  override USECXX4SO := Y
 endif
 
Index: trunk/SophyaLib/Mgr/MakefileUser.h
===================================================================
--- trunk/SophyaLib/Mgr/MakefileUser.h	(revision 478)
+++ trunk/SophyaLib/Mgr/MakefileUser.h	(revision 480)
@@ -55,9 +55,4 @@
 #### Fortran (tout ce qui est lie au Fortran est defini ici #############
 FC = f77
-ifeq ($(SITE),CCIN2P3)
-  ifeq ($(MACHEROS),AIX)
-    override FC := xlf
-  endif
-endif
 ifeq (${MACHEROS},Linux)
 #  override FC := f77
@@ -88,6 +83,5 @@
 EXE := ${PPH}/Exec/
 INC := ${DPCBASEREP}/Include/
-CCI := ${INC}/CInc/
-GLB := ${GNU}/${MACHEROS}/lib/
+GLB := /usr/local/lib/
 #--
 
@@ -100,4 +94,11 @@
 ifndef DBGFLAG
   DBGFLAG  := -g
+#  Probleme sur DEC/OSF1 -g avec g++/egcs pose probleme a l'assembleur
+#                    Reza 09/99 - On met -gcoff
+  ifeq (${MACHEROS},OSF1)
+    ifeq ($(CXX), g++)
+      override DBGFLAG := -gcoff
+    endif
+  endif
 endif
 
@@ -128,10 +129,13 @@
 #   Avec certains compilateurs C++ (KCC, aCC) , il faut fabriquer les librairies et 
 # les shared libs avec la meme commande 
-override ARCXX := 
-ifeq ($(CXX),KCC)
-ARCXX  := KCC
-endif
+override ARCXX := $(AR) 
+override ARCXXFLAGS := $(ARFLAGS) 
+#RZ0999 ifeq ($(CXX),KCC)
+#RZ0999 override  ARCXX  := KCC
+#RZ0999 override ARCXXFLAGS  := -o
+#RZ0999 endif
 ifeq ($(CXX),aCC)
-ARCXX  := aCC
+override ARCXX  := aCC 
+override ARCXXFLAGS  := -o
 endif
 
@@ -145,26 +149,9 @@
 #  Pour compiler PI, sous Linux, les includes et libs se trouve souvent ds /usr/X11/include /usr/X11/lib/
 ifeq (${MACHEROS},Linux)
-  XLDLIBS := -L/usr/X11/lib 
-  XCFLAGS := -I/usr/X11/include
+  XLDLIBS := -L/usr/X11/lib -L/usr/X11R6/lib
+  XCFLAGS := -I/usr/X11/include -I/usr/X11R6/include
   LDLIBS := -ldl
 endif
 
-# Pour RFIO
-ifeq ($(SITE),CCIN2P3)
-  XCFLAGS := $(XCFLAGS) -D RFIO -I/usr/local/include/shift
-  XLDLIBS := $(XLDLIBS) -L/usr/local/lib -lshift
-endif
-
-# Les bibliotheques gnu C pour le fort du CCPN
-ifeq ($(SITE),CCIN2P3)
- ifeq ($(CC), gcc)
-  ifeq ($(MACHEROS),HP-UX)
-     FGLIB := -L/usr/local/lib/gcc-lib/hppa1.1-hp-hpux9.05/2.7.2.1 -lgcc
-  endif
-  ifeq ($(MACHEROS),AIX)
-     FGLIB := -L/usr/local/lib/gcc-lib/rs6000-ibm-aix3.2.5/2.7.2.1 -lgcc
-  endif
- endif
-endif
 
 # Chemin pour la librairie cfitsio 
@@ -181,5 +168,5 @@
 #endif
 
-CPPFLAGS     :=  -I${INC} -I$(FITSIOREP) -D${MACHEROSD} -I$(INC)/tnt $(MODULECPPFLAGS)
+CPPFLAGS     :=  -I${INC} -I$(FITSIOREP) -D${MACHEROSD} $(MODULECPPFLAGS)
 
 # Les options selon les divers compilateurs
@@ -257,8 +244,4 @@
 endif
 
-#gcc sur Solaris
-ifeq ($(MACHEROS),SunOS)
- override NOSHLIB := Y
-endif
 
 ifeq ($(CXX), cxx)
@@ -339,6 +322,5 @@
 endif
 
-
-#  Compilateur KAI 
+# --- Compilateur KAI  (OK pour v 3.3)
 ifeq ($(CXX), KCC)
   CXXFLAGS     :=  --exceptions --rtti  --auto_instantiation --one_instantiation_per_object -D__KCC__
@@ -347,4 +329,11 @@
 endif
 
+# --- Compilateur natif CC de SGI 
+ifeq ($(MACHEROS), IRIX64)
+  ifeq ($(CXX), CC)
+    CXXFLAGS     :=  -prelink -D__SGICC__
+  endif
+endif
+
 # Autres compilateurs natifs.
 
Index: trunk/SophyaLib/Mgr/history_eros
===================================================================
--- trunk/SophyaLib/Mgr/history_eros	(revision 478)
+++ trunk/SophyaLib/Mgr/history_eros	(revision 480)
@@ -1,4 +1,8 @@
 Mgr from Mgr
 Mgr from Mgr
+-----------> Makefile.h
+   Nettoyage et MAJ Repository revision:	1.61
+-----------> Makefile.slb
+   Nettoyage et MAJ Repository revision:	1.26
 -----------> chk_cvs.csh
    Repository revision:	1.2	/projects/Eros/CVSEros/CodeCxx/Mgr/chk_cvs.csh,v
@@ -17,8 +21,10 @@
 -----------> mkmf
    Repository revision:	1.36	/projects/Eros/CVSEros/CodeCxx/Mgr/mkmf,v
+   MAJ                  1.39    pour flag powerpc - mais pas pour HP-UX slb (.sl)
 -----------> mkmfPI
    Repository revision:	1.15	/projects/Eros/CVSEros/CodeCxx/Mgr/mkmfPI,v
 -----------> mkmflib
    Repository revision:	1.11	/projects/Eros/CVSEros/CodeCxx/Mgr/mkmflib,v
+   MAJ                  1.12    $(AR) et $(ARFLAGS) -> $(ARCXX) et $(ARCXXFLAGS)
 -----------> mkmflien
    Repository revision:	1.15	/projects/Eros/CVSEros/CodeCxx/Mgr/mkmflien,v
Index: trunk/SophyaLib/Mgr/mkmf
===================================================================
--- trunk/SophyaLib/Mgr/mkmf	(revision 478)
+++ trunk/SophyaLib/Mgr/mkmf	(revision 480)
@@ -1,4 +1,4 @@
 #!/bin/csh 
-# $Id: mkmf,v 1.3 1999-10-19 10:20:20 ansari Exp $
+# $Id: mkmf,v 1.4 1999-10-20 10:25:12 ansari Exp $
 
 # creation de MakefileUser.h a partir de Makefile.h
@@ -19,4 +19,7 @@
 echo 'LIBS = -L$(LIB)' `sed -e 's/.*/-l&/' libdirs` '-lm' >> GNUmakefile
 echo 'LIBG = -L$(GLB) -lstdc++' >> GNUmakefile
+echo 'ifeq ($(HOSTTYPE), powerpc)' >> GNUmakefile
+echo '  LIBG = -L$(GLB)' >> GNUmakefile
+echo 'endif' >> GNUmakefile
 
 cat >> GNUmakefile <<EOF
Index: trunk/SophyaLib/Mgr/mkmflib
===================================================================
--- trunk/SophyaLib/Mgr/mkmflib	(revision 478)
+++ trunk/SophyaLib/Mgr/mkmflib	(revision 480)
@@ -1,4 +1,4 @@
 #!/bin/csh
-# $Id: mkmflib,v 1.1.1.1 1999-04-09 17:55:32 ansari Exp $
+# $Id: mkmflib,v 1.2 1999-10-20 10:25:12 ansari Exp $
 
 cd ../$1
@@ -48,5 +48,5 @@
 echo $libf ':' \
  `ls *.{c,cc} | comm -3 -1 $TMPDIR/exclude.sort - | sed -e 's/\.cc/.o/' | sed -e 's/\.c/.o/' | sed -e 's/^/$(OBJ)/'` >> GNUmakefile
-echo '	$(AR) $(ARFLAGS) $@ $?' >> GNUmakefile
+echo '	$(ARCXX) $(ARCXXFLAGS) $@ $?' >> GNUmakefile
 #  Pour faire compiler les instantiations automatique de cxx (DEC)
 echo 'ifeq ($(CXX),cxx)' >> GNUmakefile
Index: trunk/SophyaLib/SysTools/pdlmgr.cc
===================================================================
--- trunk/SophyaLib/SysTools/pdlmgr.cc	(revision 478)
+++ trunk/SophyaLib/SysTools/pdlmgr.cc	(revision 480)
@@ -23,4 +23,40 @@
 if ( (path.length() > 0) && (path[path.length()] != '/')  ) GetTmpDir() = path + '/';
 else GetTmpDir() = path;
+#if defined(OSF1) || defined(Linux) || defined(SunOS)
+  string cmd = "LD_LIBRARY_PATH=";
+  char* varenv=NULL;
+  varenv=getenv("LD_LIBRARY_PATH");
+#elif defined(IRIX64)
+  string cmd = "LD_LIBRARYN32_PATH=";
+  char* varenv=NULL;
+  varenv=getenv("LD_LIBRARYN32_PATH");
+
+  if (varenv == NULL) { 
+    cmd += '.';  
+    if (path.length() > 0)  cmd += ':' + path; 
+    }
+  else { 
+    if (varenv[0] != '.') cmd += ".:";
+    if (path.length() > 0)  cmd += path + ':';
+    cmd += varenv;
+    putenv(cmd.c_str());
+    }
+#elif defined(AIX)
+  string cmd = "LIBPATH=";
+  char* varenv=NULL;
+  varenv=getenv("LIBPATH");
+  if (varenv == NULL) { 
+    cmd += '.';  
+    if (path.length() > 0)  cmd += ':' + path; 
+    cmd += ":/usr/lib:/lib";
+    }
+  else { 
+    if (varenv[0] != '.') cmd += ".:";
+    if (path.length() > 0)  cmd += path + ':';
+    cmd += varenv;
+    putenv(const_cast<char *>(cmd.c_str()));
+    }
+
+#endif
 return;
 }
@@ -49,6 +85,8 @@
 
 // Compilation du fichier
-#if defined(OSF1) || defined(Linux)
+#ifndef __mac__
 cmd = "cc -c -o " + fnameobj + " " + fname;
+#else 
+cmd = "Il faut compiler !!!" + fnameobj + " " + fname;
 #endif
 rc = system(cmd.c_str());
@@ -68,6 +106,16 @@
 #if defined(OSF1) 
   cmd = "ld -shared -o " + fnameso + " -all " + fnameobj + " -none -lm -lc";
-#else
+#elif defined(Linux)
   cmd = "ld -shared -o " + fnameso + " " + fnameobj + " -lm -lc";
+#elif defined(SunOS)
+  cmd = "ld -G -o " + fnameso + " " + fnameobj + " -lm -lc";
+#elif defined(IRIX64)
+  cmd = "ld -shared -o " + fnameso + " " + fnameobj + " -lm -lc";
+#elif defined(AIX)
+  cmd = "ld -G -bnogc -bexpall -bM:1L -o " + fnameso + " " + fnameobj;
+#elif defined(HPUX)
+  cmd = "ld -b -o " + fnameso + " " + fnameobj + " -lm -lc";
+#else 
+  cmd = "ld -o " + fnameso + " " + fnameobj + " -lm -lc";
 #endif
 rc = system(cmd.c_str());
@@ -76,5 +124,4 @@
   return(NULL);
   }
-
 PDynLinkMgr* rdyn = new PDynLinkMgr(fnameso, false);
 rdyn->copy = true;
@@ -117,5 +164,9 @@
 soName = fnameso;
 
-#if defined(OSF1) || defined(Linux)
+#if defined(HPUX)
+dlhandle = NULL;
+cerr << "PDynLinkMgr::PDynLinkMgr() Not yet available on HP-UX " << endl;
+return;
+#else
 dlhandle =  dlopen(fnameso.c_str(), RTLD_NOW);
 if (dlhandle == NULL) { 
@@ -132,11 +183,14 @@
 PDynLinkMgr::~PDynLinkMgr()
 {
-#if defined(OSF1) || defined(Linux)
+#if defined(HPUX)
+cerr << "PDynLinkMgr::~PDynLinkMgr() Not yet available on HP-UX " << endl;
+return;
+#else
 if (dlhandle) dlclose(dlhandle);    dlhandle = NULL;
-#endif
 if (copy) {
   string cmd = "rm -f " + soName;
   system(cmd.c_str());
   }
+#endif
 }
 
@@ -145,10 +199,13 @@
 {
 DlFunction f = NULL;
-#if defined(OSF1) || defined(Linux)
+#if defined(HPUX)
+cerr << "PDynLinkMgr::GetFunction() Not yet available on HP-UX " << endl;
+return f;
+#else
 if (dlhandle != NULL)  
   f = (DlFunction)dlsym(dlhandle, funcname.c_str());
-#endif
-if (f == NULL) cerr << "PDynLinkMgr::PDynLinkMgr(): Error linking " << funcname << endl;
+if (f == NULL) cerr << "PDynLinkMgr::GetFunction(): Error linking " << funcname << endl;
 return(f);
-}
-
+#endif
+}
+
Index: trunk/SophyaLib/SysTools/pdlmgr.h
===================================================================
--- trunk/SophyaLib/SysTools/pdlmgr.h	(revision 478)
+++ trunk/SophyaLib/SysTools/pdlmgr.h	(revision 480)
@@ -8,7 +8,4 @@
 #include "machdefs.h"
 #include <string>
-#if defined(__KCC__)
-using std::string ;
-#endif
 
 
@@ -41,5 +38,5 @@
 #if defined(HPUX)
   shl_t dlhandle;
-#else
+#else 
   void * dlhandle;
 #endif
Index: trunk/SophyaLib/SysTools/periodic.h
===================================================================
--- trunk/SophyaLib/SysTools/periodic.h	(revision 478)
+++ trunk/SophyaLib/SysTools/periodic.h	(revision 480)
@@ -6,7 +6,4 @@
 #include "machdefs.h"
 #include <list>
-#if defined(__KCC__)
-#include <list.h>
-#endif
 
 class Periodic;
Index: trunk/SophyaLib/SysTools/psighand.cc
===================================================================
--- trunk/SophyaLib/SysTools/psighand.cc	(revision 478)
+++ trunk/SophyaLib/SysTools/psighand.cc	(revision 480)
@@ -5,14 +5,12 @@
 #include <signal.h>
 #include "psighand.h"
-#include "pexceptions.h" 
+#include "pexceptions.h"
 
-using namespace PlanckDPC;
-
-static bool sigprstate[5] = {false, false, false, false};
+static bool sigprstate[6] = {false, false, false, false, false, false};
 
 void PeidaProcessSignal(int s);
 
 /* Nouvelle-Fonction */
-void PeidaConfigureSignalhandling(bool cfpe, bool csegv, bool cquit, bool cusr1, bool cusr2) 
+void PeidaConfigureSignalhandling(bool cfpe, bool csegv, bool cint, bool cquit, bool cusr1, bool cusr2) 
 {
   struct sigaction ae, ad;
@@ -53,6 +51,20 @@
     sigprstate[1] = csegv;
     }
+
+// SIGINT
+  if (sigprstate[2] != cint) {
+    if (cquit)   { 
+      sigaction(SIGINT, &ae, NULL);
+      puts("PeidaConfigureSignalhandling(): Activating SIGINT handling (-> throw) ...");
+      }
+    else  { 
+      sigaction(SIGINT, &ad, NULL);
+      puts("PeidaConfigureSignalhandling(): Back to default SIGINT handling ...");
+      }
+    sigprstate[2] = cint; 
+    }
+  
 // SIGQUIT
-  if (sigprstate[2] != cquit) {
+  if (sigprstate[3] != cquit) {
     if (cquit)   { 
       sigaction(SIGQUIT, &ae, NULL);
@@ -63,9 +75,9 @@
       puts("PeidaConfigureSignalhandling(): Back to default SIGQUIT handling ...");
       }
-    sigprstate[2] = cquit; 
+    sigprstate[3] = cquit; 
     }
   
 // SIGUSR1
-  if (sigprstate[3] != cusr1) {
+  if (sigprstate[4] != cusr1) {
     if (cusr1)   { 
       sigaction(SIGUSR1, &ae, NULL);
@@ -76,8 +88,8 @@
       puts("PeidaConfigureSignalhandling(): Back to default SIGUSR1 handling ...");
       }
-    sigprstate[3] = cusr1;
+    sigprstate[4] = cusr1;
     }
-// SIGUSR1
-  if (sigprstate[4] != cusr2) {
+// SIGUSR2
+  if (sigprstate[5] != cusr2) {
     if (cusr2)   { 
       sigaction(SIGUSR2, &ae, NULL);
@@ -88,5 +100,5 @@
       puts("PeidaConfigureSignalhandling(): Back to default SIGUSR2 handling ...");
       }
-    sigprstate[4] = cusr2;
+    sigprstate[5] = cusr2;
     }    
 }
@@ -94,27 +106,37 @@
 void PeidaProcessSignal(int s)
 {
+string msg;
 switch(s)
   {
   case SIGFPE :
     puts("PeidaProcessSignal: ###Signal SIGFPE catched, throw catchedSIGFPE ###");
-    throw CaughtSignalExc("SIGFPE");
+    msg = "Caught SIGFPE";
+    throw ( CaughtSignalExc(msg, s) );
   case SIGSEGV :
     puts("PeidaProcessSignal: ###Signal SIGSEGV catched, throw catchedSIGSEGV ###");
-    throw CaughtSignalExc("SIGSEGV");
+    msg = "Caught SIGSEGV";
+    throw ( CaughtSignalExc(msg, s) );
   case SIGINT :
     puts("PeidaProcessSignal: ###Signal SIGINT catched, throw catchedSIGINT ###");
-    throw CaughtSignalExc("SIGINT");
+    msg = "Caught SIGINT";
+    throw ( CaughtSignalExc(msg, s) );
   case SIGQUIT :
     puts("PeidaProcessSignal: ###Signal SIGQUIT catched, throw catchedSIGQUIT ###");
-    throw CaughtSignalExc("SIGQUIT");
+    msg = "Caught SIGQUIT";
+    throw ( CaughtSignalExc(msg, s) );
   case SIGUSR1 :
     puts("PeidaProcessSignal: ###Signal SIGUSR1 catched, throw catchedSIGUSR1 ###");
-    throw CaughtSignalExc("SIGUSR1");
+    msg = "Caught SIGUSR1";
+    throw ( CaughtSignalExc(msg, s) );
   case SIGUSR2 :
     puts("PeidaProcessSignal: ###Signal SIGUSR2 catched, throw catchedSIGUSR2 ###");
-    throw CaughtSignalExc("SIGUSR2");
+    msg = "Caught SIGUSR2";
+    throw ( CaughtSignalExc(msg, s) );
   default :
     printf("PeidaProcessSignal: ###Signal %d catched, throw  inconsistentErr ### \n", s);
-    throw CaughtSignalExc("???");
+    msg = "Caught SIG???";
+    throw ( CaughtSignalExc(msg, s) );
   }
+
+// return;
 }
Index: trunk/SophyaLib/SysTools/psighand.h
===================================================================
--- trunk/SophyaLib/SysTools/psighand.h	(revision 478)
+++ trunk/SophyaLib/SysTools/psighand.h	(revision 480)
@@ -6,4 +6,6 @@
 
 #include "machdefs.h"
-void PeidaConfigureSignalhandling(bool cfpe=false, bool csegv=false, bool cquit=false, bool cusr1=false, bool cusr2=false); 
+void PeidaConfigureSignalhandling(bool cfpe=false, bool csegv=false, 
+                                  bool cint=false, bool cquit=false, 
+                                  bool cusr1=false, bool cusr2=false); 
 #endif