Index: /trunk/SophyaPI/PI/parradapter.cc
===================================================================
--- /trunk/SophyaPI/PI/parradapter.cc	(revision 484)
+++ /trunk/SophyaPI/PI/parradapter.cc	(revision 485)
@@ -9,4 +9,37 @@
 #include "parradapter.h"
 
+//++
+// Class	P1DArrayAdapter
+// Lib		PI
+// include	parradapter.h
+//
+//	Adaptateur de tableaux 1-D . La methode "Value(i)" doit etre redefinie
+//	dans une classe derivee.
+//
+//--
+//++
+// Links        Voir aussi
+// P2DArrayAdapter
+// P1DAdapter<T>
+//--
+
+//++
+// Titre        Constructeur, méthodes
+//--
+//++
+// P1DArrayAdapter(int sz)
+//	Constructeur - Tableau 1D de taille "sz"
+// double  Value(int i)
+//	Retourne la valeur de l'element "i" - virtuelle pure - doit etre 
+//	surchargee dans une classe derivee.
+// int Size()
+//	Retourne la taille du tableau
+// void DefineXCoordinate(double x0, double dx)
+//	Definition de l'axe des coordonnees correspondant a l'indice du tableau
+//	a partir d'un offser "x0" et d'un increment "dx"
+// double X(int i)
+//	Retourne l'abcisse de l'element "i"
+//--
+
 /* --Methode-- */
 P1DArrayAdapter::P1DArrayAdapter(int sz)
@@ -32,4 +65,43 @@
 return(mOx+mDx*i);
 }
+
+
+//++
+// Class	P2DArrayAdapter
+// Lib		PI
+// include	parradapter.h
+//
+//	Adaptateur de tableaux 2-D . La methode "Value(i,j)" doit etre redefinie
+//	dans une classe derivee.
+//
+//--
+//++
+// Links        Voir aussi
+// P1DArrayAdapter
+// P2DAdapter<T>
+//--
+
+//++
+// Titre        Constructeur, méthodes
+//--
+//++
+// P2DArrayAdapter(int sx=0, int sy=0)
+//	Constructeur - Tableau 2D "sx * sy"
+// void ConfigureAxes(bool invx=false, bool invy=false, bool exy=false, \
+//                    int sx=-1, int sy=-1)
+//	Definit la configuration des axes - Les axes X et Y peuvent etre
+//	inverses, et echanges. Si "sx" et "sy" sont positifs, ils definissent
+//	les nouvelles valeurs de la taille du tableau.
+// GetAxesConfiguration(bool& invx, bool& invy, bool& exy)
+//	Renvoie la configuration des axes.
+// DefineXYCoordinates(double x0, double y0, double dx, double dy)
+//	Definit le systeme de coordonnees associe aux deux axes du tableau,
+//	a partir d'un offser et d'un increment.
+// double Value(int ix, int iy)
+//	Renvoie la valeur du tableau en "(i,j)" - Doit etre definie par les 
+//	classes derivees.
+// void XYfromxy(int ix, int iy, double& x, double& y)
+//	Coordonnees "x,y" a partir d'indice du tableau
+//--
 
 /* --Methode-- */
@@ -370,2 +442,50 @@
 }
 
+//++
+// Class	P1DAdapter<T>
+// Lib		PI
+// include	parradapter.h
+//
+//	Adaptateur de tableaux 1-D, construit a partir d'un pointeur
+//	"T* data"
+//--
+//++
+// Links        Voir aussi
+// P1DArrayAdapter
+// P2DAdapter<T>
+//--
+
+//++
+// Titre        Constructeur
+//--
+//++
+// P1DAdapter<T>(T* data, int sz, bool ad=false)
+//	Constructeur a partir d'un tableau "T* data", de taille "sz".
+//	Si "ad==true", le destructeur libere l'espace memoire de "data"
+//	par delete. 
+//--
+
+//++
+// Class	P2DAdapter<T>
+// Lib		PI
+// include	parradapter.h
+//
+//	Adaptateur de tableaux 2-D, construit a partir d'un pointeur
+//	"T* data"
+//--
+//++
+// Links        Voir aussi
+// P2DArrayAdapter
+// P1DAdapter<T>
+//--
+
+//++
+// Titre        Constructeur
+//--
+//++
+// P2DAdapter(T* data, int sx, int sy, bool ad=false)
+//	Constructeur a partir d'un pointeur "T* data", representant un
+//	tableau 2D de taille "sx * sy".
+//	Si "ad==true", le destructeur libere l'espace memoire de "data"
+//	par delete. 
+//--
Index: /trunk/SophyaPI/PI/picons.cc
===================================================================
--- /trunk/SophyaPI/PI/picons.cc	(revision 484)
+++ /trunk/SophyaPI/PI/picons.cc	(revision 485)
@@ -19,5 +19,5 @@
 //	ainsi que la saisie et l'edition de commande, avec la gestion
 //	d'un buffer de rappel.
-//	de *Drawer* avec la gestion de zoom (agrandissement).
+//
 //	* Bouton-1 : Envoie le message "PIMsg_Active". Permet aussi 
 //	la selection d'un rectangle pour le copie/coller
@@ -176,4 +176,6 @@
 //++
 // Titre	Méthodes
+//	Seule les méthodes les plus usuelles sont décrites ici. Se reporter
+//	au fichier .h pour la liste complete des méthodes
 //	le type "enum PIVAType" est utilise pour definir les attributs
 //	graphiques du texte affiche dans l'objet PIConsole. Les attributs 
Index: /trunk/SophyaPI/PI/piimage.cc
===================================================================
--- /trunk/SophyaPI/PI/piimage.cc	(revision 484)
+++ /trunk/SophyaPI/PI/piimage.cc	(revision 485)
@@ -50,4 +50,9 @@
 // PIPixmap
 //--
+//++
+// Links        Voir aussi
+// PIColorMap
+// P2DArrayAdapter
+//--
 
 //++
@@ -56,5 +61,5 @@
 //++
 //  PIImage(PIContainerGen *par, const char *nom=NULL, int sx=0, int sy=0, int px=0, int py=0)
-//	Créateur
+//	Constructeur
 //  
 //--
@@ -197,4 +202,30 @@
 return;
 }
+
+//++
+// Titre	Méthodes
+//      Seule les méthodes les plus usuelles sont décrites ici. Se reporter
+//      au fichier .h pour la liste complete des méthodes
+//--
+
+//++
+// void SetImage(P2DArrayAdapter* pim, bool ad = true, bool refr=true)
+//	Associe un tableau "P2DArrayAdapter* pim" a l'objet "PIImage"
+//	pour affichage. si "ad==true", la tableau "pim" est detruit
+//	(par delete) lors de la destruction de l'objet PIImage.
+//	Si "ref==true", la fenetre est rafraichie.
+// void SetZoomWin(PIPixmap * zw, bool refr=false)
+//	Associe une fenetre "(PIPixmap * zw)" pour l'affichage
+//	d'une portion d'image agrandie.
+//	Si "refr=="true", la fenetre de zoom est rafraichie
+// SetGloVWin(PIPixmap * zw, bool refr=false)
+//	Associe une fenetre "(PIPixmap * zw)" comme fenetre de vue globale
+//	de l'image.
+//	Si "refr=="true", la fenetre de vue globale est rafraichie
+// SetCMapWin(PICMapView * cw, bool refr=false)
+//	Associe un objet "PICMapView * cw" pour l'affichage de la table
+//	des couleurs.
+//	Si "refr=="true", la fenetre de la table des couleurs est rafraichie
+//--
 
 /* --Methode-- */
@@ -369,4 +400,26 @@
 }
 
+//++
+// SetLut(double min, double max, int typlut=kLutType_Lin, \
+//        int lauto=0, bool refr=true)
+//	Definit la LUT pour l'affichage
+//	Si "refr=="true", la fenetre est rafraichie
+// SetLut(LUT *clut, bool refr=true)
+//	Associe l'objet "LUT* clut", a l'objet PIImage. "clut" doit 
+//	etre construit avec new 
+// SetZoom(int zm, bool refr=true);
+//	Changement du facteur d'agrandissement - si zm Negatif, l'image
+//	sera reduit (taille d'affichage) du facteur 1/(-zm)
+//	Si "refr=="true", la fenetre est rafraichie
+// SetZoomF(float fzm, bool refr=true)
+//	Specification du facteur d'agrandissement en valeur flottante.
+// SetColMap(PIColorMap* cmp, bool refr=true)
+//	Specification d'une nouvelle table de couleur, "PIColorMap* cmp"
+//	qui doit etre obtenu par new.
+//	Si "refr=="true", la fenetre est rafraichie
+// SetColMapId(CMapId cmapid, bool refr=true)
+//	pecification d'une nouvelle table de couleur	
+//--
+
 /* --Methode-- */
 void PIImage::SetLut(double min, double max, int typlut, int lauto, bool refr)
Index: /trunk/SophyaPI/PI/piscdrawwdg.cc
===================================================================
--- /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 484)
+++ /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 485)
@@ -46,4 +46,6 @@
 //++
 // Titre	Constructeurs, méthodes
+//	Seule les méthodes les plus usuelles sont décrites ici. Se reporter
+//	au fichier .h pour la liste complete des méthodes
 //--
 //++